// sendreceive2Dlg.cpp : implementation file
//
// This example is provided AS IS requires Cyberprinter
// Server installed in the same PC where this example
// will run.
// Keep this comments unchanged
// Cyberprinter development kit 1.0
// Author Antonio Ramirez Serpol Software
//
///////////////////////////////////////////////

#include "stdafx.h"
#include "sendreceive2.h"
#include "sendreceive2Dlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

typedef struct
{
	long RecNo;  // Record number
	int Copies;						
	CHAR Printer[MAX_PATH + 1];
	CHAR Document[MAX_PATH + 1];
	CHAR User[MAX_PATH + 1];
	CHAR PCname[MAX_PATH + 1];
	CHAR PrintDate[MAX_PATH + 1];
	CHAR PrintTime[MAX_PATH + 1];
	int job;
	CHAR Color[MAX_PATH + 1]; // BW / Color
	CHAR PaperSize[MAX_PATH + 1];
	int PageCount; // Total Page Count
	DWORD PrintStatus; // 0 = Hold, 1 = Printed, 2 = Canceled
	double cost;
} PRINTERPARAM;

typedef struct
{
						
	CHAR Line[MAX_PATH + 1];
	BOOL isWindowClass;
	
} WINDOWPARAM;

UINT CMD_SETWND;
UINT CMD_QUERYFREC;
UINT CMD_TERMINATE;
UINT	CMD_OPEN_LOGVIEWER;
UINT	CMD_CLOSE_LOGVIEWER;
UINT	CMD_SET_POP_ON;
UINT	CMD_SET_POP_OFF;
UINT	CMD_SET_PASS_IN_SERVER;
UINT	CMD_SET_RELEASE_BY_OTHERAPP;
UINT	CMD_SET_RELEASE_BY_OPERATOR;
UINT	CMD_USERMENU_ENABLE;
UINT	CMD_USERMENU_DISABLE;
UINT	CMD_RECORD_RELEASE;

/////////////////////////////////////////////////////////////////////////////
// CSendreceive2Dlg dialog

CSendreceive2Dlg::CSendreceive2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSendreceive2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSendreceive2Dlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CSendreceive2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSendreceive2Dlg)
	DDX_Control(pDX, IDC_LIST1, m_List);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSendreceive2Dlg, CDialog)
	//{{AFX_MSG_MAP(CSendreceive2Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_COPYDATA()
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON8, OnButton8)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
	ON_BN_CLICKED(IDC_BUTTON9, OnButton9)
	ON_BN_CLICKED(IDC_BUTTON10, OnButton10)
	ON_BN_CLICKED(IDC_BUTTON11, OnButton11)
	ON_BN_CLICKED(IDC_BUTTON12, OnButton12)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSendreceive2Dlg message handlers

BOOL CSendreceive2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Cyberprinter also registers the following messages
	// therfore both application and Cyberprinter understand
	// the same message
	// Just copy and paste this two lines of code into your app

	CMD_QUERYFREC = ::RegisterWindowMessage(TEXT("QueryFromRecord"));
	CMD_TERMINATE = ::RegisterWindowMessage(TEXT("TerminateApplication"));
	CMD_OPEN_LOGVIEWER = ::RegisterWindowMessage(TEXT("OpenLogViewer"));
	CMD_CLOSE_LOGVIEWER = ::RegisterWindowMessage(TEXT("CloseLogViewer"));
	CMD_SET_POP_ON = ::RegisterWindowMessage(TEXT("SetPopOn"));
	CMD_SET_POP_OFF = ::RegisterWindowMessage(TEXT("SetPopOff"));
	CMD_SET_PASS_IN_SERVER = ::RegisterWindowMessage(TEXT("SetPassinServer"));
	CMD_SET_RELEASE_BY_OTHERAPP = ::RegisterWindowMessage(TEXT("ReleaseByOtherApp"));
	CMD_SET_RELEASE_BY_OPERATOR = ::RegisterWindowMessage(TEXT("ReleaseByOperator"));
	CMD_USERMENU_ENABLE = ::RegisterWindowMessage(TEXT("UserMenuEnable"));
	CMD_USERMENU_DISABLE = ::RegisterWindowMessage(TEXT("UserMenuDisable"));
	CMD_RECORD_RELEASE = ::RegisterWindowMessage(TEXT("RecordRelease"));

	CEdit *m_edit = (CEdit *) GetDlgItem(IDC_EDIT2);

	// You need to tell Cyberprinter where to send messages to
	// Caption name of the window need to be the same as the one your are
	// sending 'YourApplication' (see dialog caption)
	// You can also send a class name to avoid problems when changing caption
	// uncomment the first line and comment the second one
	// #32770 is the class name for a generic dialog window
	// change to your own

	//SendDataToApp("#32770",1); // 1 = class, 0=window
	SendDataToApp("YourApplication",0); // 1 = class, 0=window

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	m_edit->SetWindowText("1");
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CSendreceive2Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CSendreceive2Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CSendreceive2Dlg::OnOK() 
{
	// TODO: Add extra validation here
	CEdit *m_edit = (CEdit *) GetDlgItem(IDC_EDIT2);
	// Find if Cyberprinter is running and ready to receive messages
	// CyberprinterWindow is allways the name of the active message receiver
	// do not change this name
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				CString SFromRec;
				m_edit->GetWindowText(SFromRec);
				long lFromRec=atol(SFromRec); // Get Record to start getting data from
				//                               Here I Ask to query database, then the calling window, from record number
				BOOL sent=::PostMessage(hTarget, CMD_QUERYFREC, NULL, (LPARAM)lFromRec);
			}
			

}


BOOL CSendreceive2Dlg::OnCopyData(CWnd* pWnd, COPYDATASTRUCT* pData) 
{
	
 // this is where all the information from Cyberprinter will arrive
 // if size doesn't match we don't know what this is

// when PrintStatus=0 then is in hold state
// when PrintStatus=1 then is in printing state
// when PrintStatus=2 then is in delete state
// when PrintStatus=3 then log viewer dialog is closing
// when PrintStatus=4 then log viewer dialog is opened

	if( pData->cbData == sizeof( PRINTERPARAM ) )
		{
		CListBox	*m_ListPrinted= (CListBox *) GetDlgItem(IDC_LIST1);
		CListBox	*m_ListHold= (CListBox *) GetDlgItem(IDC_LIST2);
		CListBox	*m_ListDeleted= (CListBox *) GetDlgItem(IDC_LIST3);
		CButton *m_open = (CButton *) GetDlgItem(IDC_RADIO1);
		CButton *m_close = (CButton *) GetDlgItem(IDC_RADIO2);
		PRINTERPARAM pp;
		memcpy( &pp, pData->lpData, sizeof( PRINTERPARAM ) );
		int job=pp.job;
		char sjob[20];
		itoa(job,sjob,10);
		int copies=pp.Copies;
		int PageCount=pp.PageCount;
		long RecNo=pp.RecNo;
		LPCTSTR document=pp.Document;
		LPCTSTR printer=pp.Printer;
		LPCTSTR PrintedDate=pp.PrintDate;
		LPCTSTR PrintTime=pp.PrintTime;
		LPCTSTR PCname=pp.PCname;
		LPCTSTR User=pp.User;
		LPCTSTR PaperSize=pp.PaperSize;
		LPCTSTR Color=pp.Color;
		CString cad=sjob;
		cad=cad+",";
		cad=cad+document;
		double cost=pp.cost;
		if (pp.PrintStatus==1){
		m_ListPrinted->AddString(cad);
		}
		if (pp.PrintStatus==0){
		m_ListHold->AddString(cad);
		}
		if (pp.PrintStatus==2){
		m_ListDeleted->AddString(cad);
		}	
		if (pp.PrintStatus==4){
		m_open->SetCheck(TRUE);
		m_close->SetCheck(FALSE);
		}
		if (pp.PrintStatus==3){
		m_open->SetCheck(FALSE);
		m_close->SetCheck(TRUE);
		}
		}

	return CDialog::OnCopyData(pWnd, pData);
}

void CSendreceive2Dlg::OnButton1() 
{
	// Send a command to exit Cyberprinter
	// No password is required it will exit every time
	CEdit *m_edit = (CEdit *) GetDlgItem(IDC_EDIT2);
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				
				BOOL sent=::PostMessage(hTarget, CMD_TERMINATE, NULL,(LPARAM)7777); // confirmation code
			}
	
}
LRESULT CSendreceive2Dlg::SendDataToApp(CString WindowCaption, BOOL isWindowClass)
{
	// Here we are passing the window name (caption) or the window class name
	// From our application to Cyberprinter. Cyberprinter uses this information
	// To know where to send information to.
			WINDOWPARAM pp;
			
			for (int x=0;x<WindowCaption.GetLength();x++)
				pp.Line[x]=WindowCaption[x];
			pp.Line[x]='\0';
			pp.isWindowClass=isWindowClass;

			COPYDATASTRUCT	cds;
			cds.dwData = 0;
			cds.cbData = sizeof( pp );
			cds.lpData = &pp;
			LRESULT res = FALSE;
			HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	
			if (!hTarget)
			{
				//AfxMessageBox("Can not find target");
			}
			else
			{
				res=::SendMessage( hTarget, WM_COPYDATA, NULL, (LPARAM) &cds );
			}
		return res;
}

BOOL CSendreceive2Dlg::SetJobStatus(CString PrinterName, int JobID, DWORD PrinterStatus)
{
	// this code is to release a print job from its hold state
	// printout will be printed now

		HANDLE hPrinter;
		PRINTER_DEFAULTS PDef;
		PDef.pDatatype = NULL;                  // Not needed on  Win9x
		PDef.pDevMode = NULL;                 // Not needed on  Win9x
		PDef.DesiredAccess = PRINTER_ALL_ACCESS;      // Not needed on Win9x


				if( ! OpenPrinter( PrinterName.GetBuffer(PrinterName.GetLength()), &hPrinter, &PDef ) ){
					DWORD Glast=GetLastError();
					return FALSE;

					}else{
						
						BOOL IsPauseOn=SetPrinter(hPrinter,0,NULL,PrinterStatus); //PRINTER_CONTROL_RESUME PRINTER_CONTROL_PAUSE
						DWORD Glast=GetLastError();
				
						BOOL status=SetJob(hPrinter,JobID,0,NULL,JOB_CONTROL_RESUME);  // JOB_CONTROL_CANCEL JOB_CONTROL_PAUSE JOB_CONTROL_RESTART JOB_CONTROL_RESUME
						if (status){	
							Sleep(500);
						}
					} 

return TRUE;	
}

void CSendreceive2Dlg::OnButton2() 
{
	// TODO: Add your control notification handler code here
	CEdit *m_edit = (CEdit *) GetDlgItem(IDC_EDIT2);
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				
				BOOL sent=::PostMessage(hTarget, CMD_OPEN_LOGVIEWER, NULL,NULL); // confirmation code
			}
}

void CSendreceive2Dlg::OnButton3() 
{
	// TODO: Add your control notification handler code here
	CEdit *m_edit = (CEdit *) GetDlgItem(IDC_EDIT2);
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				
				BOOL sent=::PostMessage(hTarget, CMD_CLOSE_LOGVIEWER, NULL,NULL); // confirmation code
			}
}

void CSendreceive2Dlg::OnButton4() 
{
	// TODO: Add your control notification handler code here
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				
				BOOL sent=::PostMessage(hTarget, CMD_SET_POP_ON, NULL,NULL); // confirmation code
			}
}

void CSendreceive2Dlg::OnButton5() 
{
	// TODO: Add your control notification handler code here
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				
				BOOL sent=::PostMessage(hTarget, CMD_SET_POP_OFF, NULL,NULL); // confirmation code
			}
}

void CSendreceive2Dlg::OnButton6() 
{
	// TODO: Add your control notification handler code here
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				
				BOOL sent=::PostMessage(hTarget, CMD_SET_PASS_IN_SERVER, NULL,NULL); // confirmation code
			}
}

void CSendreceive2Dlg::OnButton8() 
{
	// TODO: Add your control notification handler code here
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				
				BOOL sent=::PostMessage(hTarget, CMD_SET_RELEASE_BY_OPERATOR, NULL,NULL); // confirmation code
			}
}

void CSendreceive2Dlg::OnButton7() 
{
	// TODO: Add your control notification handler code here
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				
				BOOL sent=::PostMessage(hTarget, CMD_SET_RELEASE_BY_OTHERAPP, NULL,NULL); // confirmation code
			}
}

void CSendreceive2Dlg::OnButton9() 
{
	// TODO: Add your control notification handler code here
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				
				BOOL sent=::PostMessage(hTarget, CMD_USERMENU_ENABLE, NULL,NULL); // confirmation code
			}
}

void CSendreceive2Dlg::OnButton10() 
{
	// TODO: Add your control notification handler code here
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				
				BOOL sent=::PostMessage(hTarget, CMD_USERMENU_DISABLE, NULL,NULL); // confirmation code
			}
}

void CSendreceive2Dlg::OnButton11() 
{
	// TODO: Add your control notification handler code here
	CEdit *m_edit = (CEdit *) GetDlgItem(IDC_EDIT1);
	// Find if Cyberprinter is running and ready to receive messages
	// CyberprinterWindow is allways the name of the active message receiver
	// do not change this name
	
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				CString sRecordNo;
				m_edit->GetWindowText(sRecordNo);
				int nRecordNo=atoi(sRecordNo);
				int release=TRUE; 
				BOOL sent=::PostMessage(hTarget, CMD_RECORD_RELEASE, (WPARAM)release, (LPARAM)nRecordNo);
			}	
}

void CSendreceive2Dlg::OnButton12() 
{
	// TODO: Add your control notification handler code here
		CEdit *m_edit = (CEdit *) GetDlgItem(IDC_EDIT1);
	// Find if Cyberprinter is running and ready to receive messages
	// CyberprinterWindow is allways the name of the active message receiver
	// do not change this name
	
	HWND hTarget = ::FindWindow(NULL, "CyberprinterWindow"); // This invisible window will be active all the time when cyberprinter is running
	

			if (!hTarget)
			{
				AfxMessageBox("Can not find target");
			}
			else
			{
				CString sRecordNo;
				m_edit->GetWindowText(sRecordNo);
				int nRecordNo=atoi(sRecordNo);
				int release=FALSE; 
				BOOL sent=::PostMessage(hTarget, CMD_RECORD_RELEASE, (WPARAM)release, (LPARAM)nRecordNo);
			}	
}
